"use strict";
// @ts-nocheck
// The types for CodeMirror don't accept a RegExp for 'open' and 'close'
Object.defineProperty(exports, "__esModule", { value: true });
const codemirror_1 = require("@jupyterlab/codemirror");
require("codemirror/lib/codemirror");
require("codemirror/mode/haskell/haskell");
require("codemirror/mode/r/r");
function defineIHaskellMode({ CodeMirror }) {
    codemirror_1.Mode.ensure("haskell");
    codemirror_1.Mode.ensure("r");
    CodeMirror.defineMode("ihaskell", (config) => {
        let hmode = CodeMirror.getMode(config, "haskell");
        return CodeMirror.multiplexingMode(hmode, {
            open: /:(?=!)/,
            close: /^(?!!)/,
            mode: CodeMirror.getMode(config, "text/plain"),
            delimStyle: "delimit"
        }, {
            open: /\[r\||\[rprint\||\[rgraph\|/,
            close: /\|\]/,
            mode: CodeMirror.getMode(config, "text/x-rsrc"),
            delimStyle: "delimit"
        });
    });
    CodeMirror.defineMIME("text/x-ihaskell", "ihaskell");
    CodeMirror.modeInfo.push({
        ext: ['hs'],
        mime: "text/x-ihaskell",
        mode: 'ihaskell',
        name: 'ihaskell'
    });
}
exports.defineIHaskellMode = defineIHaskellMode;
